<?php
require_once 'model/usuario.entidad.php';
require_once 'model/usuario.model.php';
require_once 'model/pregunta.model.php';
require_once 'model/pregunta.entidad.php';
require_once 'model/parametro.model.php';
require_once 'model/parametro.entidad.php';
require_once 'model/competencia.model.php';
require_once 'model/competencia.entidad.php';
require_once 'model/comportamiento.entidad.php';

class PreguntaController extends helpers
{
    private $usuario_model;
    private $pregunta_model;
    private $parametro_model;

    public function __CONSTRUCT()
    {
        $this->usuario_model = new UsuarioModel();
        $this->pregunta_model = new PreguntaModel();
        $this->parametro_model = new ParametroModel();
    }

    public function Index()
    {
        $parametro = $this->parametro_model->ListarParametros();
        $pregunta = $this->pregunta_model->Listar();

        require_once 'view/header.php';
        require_once 'view/webforms/wfapregunta.php';
        echo "<script type='text/javascript'>
                    $(document).ready(function (){
                        $('.catalogos').addClass('active');
                    });
              </script>";
        require_once 'view/footer.php';
    }

    public function FrmGuardarPregunta()
    {
        $parametro = $this->parametro_model->ListarParametros();
        $competencias = $this->pregunta_model->Listar_comportamientos();
        require_once 'view/webforms/wfapreguntaa.php';
    }

    public function GuardarPregunta()
    {
        $ven = new Pregunta();
        if ($_POST['Pregunta_Id'] != 0 ? $ven->__SET('Pregunta_Id', $_POST['Pregunta_Id']) : '');
        $ven->__SET('competenciadetalle_Id', $_POST['competenciadetalle_Id']);
        $ven->__SET('sPreCodigo', $_POST['sPreCodigo']);
        $ven->__SET('sPreDescripcion', $_POST['sPreDescripcion']);
        $ven->__SET('nPreEliminado', 0);
        $ven->__SET('nPreEstado', $_POST['nPreEstado']);
        $ven->__SET('nPreUsuario_Id', $_SESSION['usu_codigo']);

        if ($_POST['Pregunta_Id'] != 0) {
            $this->pregunta_model->Editar($ven);
        } else {
            $this->pregunta_model->Guardar($ven);
        }

        echo "<meta http-equiv='refresh' content='0'>";
    }


    public function FrmEditarPregunta()
    {
        $datos = $this->pregunta_model->Buscar($_POST['Pregunta_Id']);
        $competencias = $this->pregunta_model->Listar_comportamientos();

        foreach ($datos as $r):
            require_once 'view/webforms/wfapreguntaa.php';
        endforeach;
    }

    public function getPregunta($Pregunta_Id)
    {
        $datos = $this->pregunta_model->Buscar($Pregunta_Id);
        foreach ($datos as $r):
            $competenciaNombre = $this->pregunta_model->ObtenerCompetencia($r->__GET('competenciadetalle_Id'));
            $competenciaDetalle = $this->pregunta_model->ObtenerCompetenciaDetalle($r->__GET('competenciadetalle_Id'));
            echo " <tbody>
                      <tr>
                         <td>
                            <input type='hidden' name='IdPregunta_Print' id='IdPregunta_Print' value='" . $r->__GET('Pregunta_Id') . "'> 
                            Código
                         </td>
                         <td>" . $r->__GET('sPreCodigo') . "</td>
                      </tr>
                      <tr>
                         <td>Descripción</td>
                         <td>" . $r->__GET('sPreDescripcion') . "</td>
                      </tr>  
                      <tr>
                         <td>Dimension</td>
                         <td>" . $competenciaNombre . "</td>
                      </tr>
                      <tr>
                         <td>Subdimensión</td>
                         <td>" . $competenciaDetalle . "</td>
                      </tr>
                      <tr>
                         <td>Estado</td>
                         <td>" . ($r->__GET('nPreEstado') == '1' ? '<span class="label bg-green">Habilitado</span>' : '<span class="label bg-danger">Inhabilitado</span>') . "</td>
                      </tr>
                   </tbody>";
        endforeach;
    }

    public function MostrarPregunta()
    {
        echo $this->getPregunta($_POST['Pregunta_Id']);
    }

    public function EliminarPregunta()
    {
        $ven = new Pregunta();
        $ven->__SET('Pregunta_Id', $_POST['idPregunta']);
        $ven->__SET('nPreUsuario_Id', $_SESSION['usu_codigo']);
        $this->pregunta_model->Eliminar($ven);
        echo '<script type="text/javascript">window.location="?c=Pregunta&a=Index";</script>';
    }

    public function PDFPregunta()
    {
        require_once 'view/webforms/PDF/personal.php';
    }
}
