<?php    
    require_once 'model/resultado.entidad.php';
    require_once 'model/resultado.model.php';
    require_once 'model/usuario.entidad.php';
    require_once 'model/usuario.model.php';
    require_once 'model/parametro.model.php';
    require_once 'model/parametro.entidad.php';
    require_once 'model/resultadodetalle.model.php';
    require_once 'model/resultadodetalle.entidad.php';
    require_once 'model/reporte.model.php';
    require_once 'model/reporte.entidad.php';

    require_once 'model/areaTrabajo.entidad.php';
    require_once 'model/areaTrabajo.model.php';
    require_once 'model/cargoTrabajo.entidad.php';
    require_once 'model/cargoTrabajo.model.php';
    require_once 'model/anoTrabajo.entidad.php';
    require_once 'model/anoTrabajo.model.php';
    require_once 'model/rangoEdad.entidad.php';
    require_once 'model/rangoEdad.model.php';
    require_once 'model/modalidadContrato.entidad.php';
    require_once 'model/modalidadContrato.model.php';

    class ReporteController extends helpers {
        private $producto_model;
        private $usuario_model;
        private $parametro_model;
        private $productogrupoelectrogeno_model;
        private $resultadodetalle_model;
        private $reporte_model;
        private $resultado_model;

        private $area_trabajo;
        private $cargo_trabajo;
        private $anio_trabajo;
        private $rango_edad;
        private $modalidad_contrato;

        public function __CONSTRUCT(){
            $this->resultado_model = new ResultadoModel();
            // $this->producto_model = new ProductoModel();
            $this->usuario_model = new UsuarioModel();
            $this->parametro_model = new ParametroModel();
            // $this->productogrupoelectrogeno_model = new ProductogrupoelectrogenoModel();
            $this->resultadodetalle_model = new ResultadodetalleModel();
            $this->reporte_model = new ReporteModel();

            $this->area_trabajo = new AreaTrabajoModel();
            $this->cargo_trabajo = new CargoTrabajoModel();
            $this->anio_trabajo = new AnoTrabajoModel();
            $this->rango_edad = new RangoEdadModel();
            $this->modalidad_contrato = new ModalidadContratoModel();

        }

              //AVANCE DE LAS EVALUACIONES 
      public function IndexAvance(){
            $parametro = $this->parametro_model->ListarParametros();

            $areas = $this->area_trabajo->Listar();
            $cargos = $this->cargo_trabajo->Listar();
            $anios = $this->anio_trabajo->Listar();
            $edades = $this->rango_edad->Listar();
            $contrataciones = $this->modalidad_contrato->Listar();

            $area_id = isset($_POST['area_Id']) ? $_POST['area_Id'] : 0;
            $cargo_Id = isset($_POST['cargo_Id']) ? $_POST['cargo_Id'] : 0;
            $anio_Id = isset($_POST['ano_Id']) ? $_POST['ano_Id'] : 0;
            $edad_Id = isset($_POST['edad_Id']) ? $_POST['edad_Id'] : 0;
            $contracion_Id = isset($_POST['Contratacion_Id']) ? $_POST['Contratacion_Id'] : 0;

            $reporte= $this->reporte_model->ListarAvance($area_id,$cargo_Id,$anio_Id,$edad_Id,$contracion_Id);

            require_once 'view/header.php';  
            require_once 'view/webforms/rptavance.php';
            echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
            require_once 'view/footer.php'; 
      }

      public function IndexResultadoDimensiones() {
        $parametro = $this->parametro_model->ListarParametros();

        $areas = $this->area_trabajo->Listar();
        $cargos = $this->cargo_trabajo->Listar();
        $anios = $this->anio_trabajo->Listar();
        $edades = $this->rango_edad->Listar();
        $contrataciones = $this->modalidad_contrato->Listar();

        $area_id = isset($_POST['area_Id']) ? $_POST['area_Id'] : 0;
        $cargo_Id = isset($_POST['cargo_Id']) ? $_POST['cargo_Id'] : 0;
        $anio_Id = isset($_POST['ano_Id']) ? $_POST['ano_Id'] : 0;
        $edad_Id = isset($_POST['edad_Id']) ? $_POST['edad_Id'] : 0;
        $contracion_Id = isset($_POST['Contratacion_Id']) ? $_POST['Contratacion_Id'] : 0;

        $reporte= $this->reporte_model->ListarResultadoDimensiones($area_id,$cargo_Id,$anio_Id,$edad_Id, $contracion_Id);

        require_once 'view/header.php';  
        require_once 'view/webforms/rptresultadodimensiones.php';
        echo "<script type='text/javascript'>
                    $(document).ready(function (){
                        $('.reportes').addClass('active');
                    });
              </script>";
        require_once 'view/footer.php'; 
      }

      public function IndexResultadoSubdimension() {
        $parametro = $this->parametro_model->ListarParametros();

        $areas = $this->area_trabajo->Listar();
        $cargos = $this->cargo_trabajo->Listar();
        $anios = $this->anio_trabajo->Listar();
        $edades = $this->rango_edad->Listar();
        $contrataciones = $this->modalidad_contrato->Listar();

        $area_id = isset($_POST['area_Id']) ? $_POST['area_Id'] : 0;
        $cargo_Id = isset($_POST['cargo_Id']) ? $_POST['cargo_Id'] : 0;
        $anio_Id = isset($_POST['ano_Id']) ? $_POST['ano_Id'] : 0;
        $edad_Id = isset($_POST['edad_Id']) ? $_POST['edad_Id'] : 0;
        $contracion_Id = isset($_POST['Contratacion_Id']) ? $_POST['Contratacion_Id'] : 0;

        $reporte= $this->reporte_model->ListarResultadoSubDimensiones($area_id,$cargo_Id,$anio_Id,$edad_Id, $contracion_Id);

        require_once 'view/header.php';  
        require_once 'view/webforms/rptresultadosubdimensiones.php';
        echo "<script type='text/javascript'>
                    $(document).ready(function (){
                        $('.reportes').addClass('active');
                    });
              </script>";
        require_once 'view/footer.php'; 
      }

      public function IndexResultadoPregunta() {
        $parametro = $this->parametro_model->ListarParametros();

        $areas = $this->area_trabajo->Listar();
        $cargos = $this->cargo_trabajo->Listar();
        $anios = $this->anio_trabajo->Listar();
        $edades = $this->rango_edad->Listar();
        $contrataciones = $this->modalidad_contrato->Listar();

        $area_id = isset($_POST['area_Id']) ? $_POST['area_Id'] : 0;
        $cargo_Id = isset($_POST['cargo_Id']) ? $_POST['cargo_Id'] : 0;
        $anio_Id = isset($_POST['ano_Id']) ? $_POST['ano_Id'] : 0;
        $edad_Id = isset($_POST['edad_Id']) ? $_POST['edad_Id'] : 0;
        $contracion_Id = isset($_POST['Contratacion_Id']) ? $_POST['Contratacion_Id'] : 0;

        $reporte= $this->reporte_model->ListarResultadoPreguntas($area_id,$cargo_Id,$anio_Id,$edad_Id, $contracion_Id);

        require_once 'view/header.php';  
        require_once 'view/webforms/rptresultadopreguntas.php';
        echo "<script type='text/javascript'>
                    $(document).ready(function (){
                        $('.reportes').addClass('active');
                    });
              </script>";
        require_once 'view/footer.php'; 
      }

      public function generarPDFAvanceEvaluaciones() {
          // consulta
          $area_id = isset($_POST['area_id']) ? $_POST['area_id'] : 0;
          $cargo_Id = isset($_POST['cargo_Id']) ? $_POST['cargo_Id'] : 0;
          $edad_Id = isset($_POST['edad_Id']) ? $_POST['edad_Id'] : 0;
          $anio_Id = isset($_POST['ano_Id']) ? $_POST['ano_Id'] : 0;
          $contracion_Id = isset($_POST['Contratacion_Id']) ? $_POST['Contratacion_Id'] : 0;

          $reporte = $this->reporte_model->ListarAvance($area_id, $cargo_Id, $anio_Id, $edad_Id, $contracion_Id);

          require_once 'helpers/ExcelCustom.php';
        
      }

      public function generarExcelResultadoDimensiones() {
          // consulta
          $area_id = isset($_POST['area_id']) ? $_POST['area_id'] : 0;
          $cargo_Id = isset($_POST['cargo_Id']) ? $_POST['cargo_Id'] : 0;
          $edad_Id = isset($_POST['edad_Id']) ? $_POST['edad_Id'] : 0;
          $anio_Id = isset($_POST['ano_Id']) ? $_POST['ano_Id'] : 0;
          $contracion_Id = isset($_POST['Contratacion_Id']) ? $_POST['Contratacion_Id'] : 0;

          $reporte= $this->reporte_model->ListarResultadoDimensiones($area_id,$cargo_Id,$anio_Id,$edad_Id, $contracion_Id);

          require_once 'helpers/ExcelResultadoDimensiones.php';
        
      }

      public function generarExcelResultadoSubDimensiones() {
          // consulta
          $area_id = isset($_POST['area_id']) ? $_POST['area_id'] : 0;
          $cargo_Id = isset($_POST['cargo_Id']) ? $_POST['cargo_Id'] : 0;
          $edad_Id = isset($_POST['edad_Id']) ? $_POST['edad_Id'] : 0;
          $anio_Id = isset($_POST['ano_Id']) ? $_POST['ano_Id'] : 0;
          $contracion_Id = isset($_POST['Contratacion_Id']) ? $_POST['Contratacion_Id'] : 0;

          $reporte= $this->reporte_model->ListarResultadoSubDimensiones($area_id,$cargo_Id,$anio_Id,$edad_Id, $contracion_Id);

          require_once 'helpers/ExcelResultadoSubDimensiones.php';
        
      }

      public function generarExcelResultadoPreguntas() {
          // consulta
          $area_id = isset($_POST['area_id']) ? $_POST['area_id'] : 0;
          $cargo_Id = isset($_POST['cargo_Id']) ? $_POST['cargo_Id'] : 0;
          $edad_Id = isset($_POST['edad_Id']) ? $_POST['edad_Id'] : 0;
          $anio_Id = isset($_POST['ano_Id']) ? $_POST['ano_Id'] : 0;
          $contracion_Id = isset($_POST['Contratacion_Id']) ? $_POST['Contratacion_Id'] : 0;

          $reporte= $this->reporte_model->ListarResultadoPreguntas($area_id,$cargo_Id,$anio_Id,$edad_Id, $contracion_Id);

          require_once 'helpers/ExcelResultadoPreguntas.php';
        
      }

        
        public function Index(){
            $parametro = $this->parametro_model->ListarParametros();

            $resultado = $this->reporte_model->ListarConsolidado(
         
              isset($_POST['fechaInicio']) ? $_POST['fechaInicio'] : date('d-m-Y', strtotime(date('d-m-Y'))), 
                  isset($_POST['fechaFin']) ? $_POST['fechaFin'] : date('d-m-Y', strtotime(date('d-m-Y')))
              );

            require_once 'view/header.php';  
            require_once 'view/webforms/wfareporte.php';
            echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
            require_once 'view/footer.php'; 
        }

        public function IndexGenCompetencia(){
            $parametro = $this->parametro_model->ListarParametros();
            //$producto= $this->resultado_model->Listar();
            $resultado = $this->reporte_model->ListarConsolidadoRep(
         
              isset($_POST['fechaInicio']) ? date('Y-m-d', strtotime($_POST['fechaInicio'])) : date('Y-m-d', strtotime(date('d-m-Y'))), 
                  isset($_POST['fechaFin']) ? date('Y-m-d', strtotime($_POST['fechaFin'])) : date('Y-m-d', strtotime(date('d-m-Y')))
              );

            require_once 'view/header.php';  
            require_once 'view/webforms/wfareportegencompetencia.php';
            echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
            require_once 'view/footer.php'; 
        }

        public function IndexGenComportamiento(){
            $parametro = $this->parametro_model->ListarParametros();
            //$producto= $this->resultado_model->Listar();
            $resultado = $this->reporte_model->ListarConsolidadoRep(
         
              isset($_POST['fechaInicio']) ? date('Y-m-d', strtotime($_POST['fechaInicio'])) : date('Y-m-d', strtotime(date('d-m-Y'))), 
                  isset($_POST['fechaFin']) ? date('Y-m-d', strtotime($_POST['fechaFin'])) : date('Y-m-d', strtotime(date('d-m-Y')))
              );

            require_once 'view/header.php';  
            require_once 'view/webforms/wfareportegencomportamiento.php';
            echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
            require_once 'view/footer.php'; 
        }

        public function IndexAutoHeteroPercepcion(){
            $parametro = $this->parametro_model->ListarParametros();
            //$producto= $this->resultado_model->Listar();
            $resultado = $this->reporte_model->ListarConsolidadoRep(
         
              isset($_POST['fechaInicio']) ? date('Y-m-d', strtotime($_POST['fechaInicio'])) : date('Y-m-d', strtotime(date('d-m-Y'))), 
                  isset($_POST['fechaFin']) ? date('Y-m-d', strtotime($_POST['fechaFin'])) : date('Y-m-d', strtotime(date('d-m-Y')))
              );

            require_once 'view/header.php';  
            require_once 'view/webforms/wfareporteautoheteroperc.php';
            echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
            require_once 'view/footer.php'; 
        }

        public function MostrarResultadoTestJefeValidar(){
          echo json_encode($this->resultado_model->MostrarResultadoIndividualJefeRep($_POST['Personal_Id'],$_POST['Evaluacion_Id'],$_POST['Cuestionario_Id']));
        }

        public function MostrarResultadoTestJefe(){
          $datos= $this->resultado_model->MostrarResultadoIndividualJefeRep($_POST['Personal_Id'],$_POST['Evaluacion_Id'],$_POST['Cuestionario_Id']);
            //haciendo que el boton guardar aparezca o desaparezca
            foreach ($datos as $ss) {
              $_SESSION["estResultado"]=1;
            }
            
            $resdetalle= $this->resultadodetalle_model->MostrarResultadoIndividualDetalleJefeReporte($_POST['Personal_Id'],$_POST['Evaluacion_Id'],$_POST['Cuestionario_Id']);
            //mostrando los ponderados de cada competencia
            $resdetallePond= $this->resultadodetalle_model->MostrarResultadoIndividualDetalleJefeChart($_POST['Personal_Id'],$_POST['Evaluacion_Id'],$_POST['Cuestionario_Id']);
            foreach ($datos as $r):
              $resultadoFinal=$r->__GET('PuntajeFinal');
              if ($resultadoFinal>0) {
                if ($resultadoFinal>=0 && $resultadoFinal<=1) {
                  $resObtFinal= "<font color='Red'><b style='color:red;'>BÁSICO</b></font>";
                }
                if ($resultadoFinal>=1.01 && $resultadoFinal<=2) {
                  $resObtFinal= "<font color='Orange'><b style='color:red;'>INTERMEDIO</b></font>";
                }
                if ($resultadoFinal>=2.01 && $resultadoFinal<=3) {
                  $resObtFinal= "<font color='Yellow'><b style='color:red;'>AVANZADO</b></font>";
                }
                if ($resultadoFinal>=3.01 && $resultadoFinal<=4) {
                  $resObtFinal= "<font color='Green'><b style='color:red;'>EXPERTO</b></font>";
                }
              }
                echo " 
                        
                        <thead>
                            <tr>
                                <th colspan=2><center>".$r->__GET('Evaluacion')."</center></th>
                            </tr>
                        </thead>
                        <tbody>
                          <tr>
                             <td colspan=2><b>EVALUADO:</b></td>
                          </tr>
                          <tr>
                             <td>NOMBRE: </td>
                             <td>".$r->__GET('Evaluado')."</td>
                          </tr>  
                          <tr>
                             <td>PUESTO: </td>
                             <td>".$r->__GET('PuestoEvaluado')."</td>
                          </tr>  
                          <tr>
                             <td>AREA: </td>
                             <td>".$r->__GET('Area')."</td>
                          </tr> 
                          <tr>
                             <td>FECHA INGRESO:</td>
                             <td>".date('d/m/Y', strtotime($r->__GET('FechaReingreso')))."</td>
                          </tr>
                          
                          <tr>
                            <td>RESULTADO:</td>
                            <td style='width: 100%;'>
                            <hr style='margin-bottom: 5px; margin-top: 5px;'>
                            <table class='table table-striped text-center' style='width: 100%;' cellpadding='0' cellspacing='0'>
                                <thead>
                                  <tr>
                                      <th style='width: 30%;'>PUNTAJE</th>
                                      <th style='width: 20%;'>NIVEL ALCANZADO</th>
                                  </tr>                                
                                </thead>
                                <tbody>   
                       
                     ";
                     //foreach ($resdetalle as $rd){
                              echo "    
                                  <tr>
                                    <td>".$r->__GET('PuntajeFinal')."</td>
                                    <td>".$resObtFinal."</td>
                                </tr>

                                <tr>
                                    <td></td>
                                    <td></td>
                                    <td></td>
                                </tr>
                                ";
                     //}
                        echo "</tbody>
                        </table>
                        </td>
                        </tr><br/>
                        <tr>
                          <td colspan=2><div class='html2pdf__page-break'></div>
                            <canvas id='myChart' width='400' height='300'></canvas>
                          </td>
                        </tr>
                        <tr>
                          <td colspan=2 style='width: 100%;'>
                            <table class='table text-center table-hover table-bordered'>
                              <thead>
                                <tr>
                                  <td colspan=5>Promedio de Evaluados por Comportamiento</td>
                                </tr>
                                <tr>
                                  <th style='width: 60%;'>COMPORTAMIENTO</th>
                                  <th style='width: 10%;'>AUTO</th>
                                  <th style='width: 10%;'>JEFE</th>
                                  <th style='width: 10%;'>SUB</th>
                                  <th style='width: 10%;'>PAR</th>
                                </tr> 
                              </thead>
                              <tbody>";
                              $var="";
                      foreach ($resdetalle as $rd) {
                          
                          if ($rd->__GET('Competencia')!=$var) {
                            foreach ($resdetallePond as $pond) {
                              if ($pond['Competencia']==$rd->__GET('Competencia')) {
                                echo "<tr bgcolor='#CEE3F6'>
                                  <td colspan><b>".$pond['Competencia']."</b></td>
                                  <td colspan>".$pond['AUTO']."</td>
                                  <td colspan>".$pond['JEFE']."</td>
                                  <td colspan>".$pond['SUB']."</td>
                                  <td colspan>".$pond['PARES']."</td>
                                </tr>";
                              }
                            }
                            
                            $var=$rd->__GET('Competencia');
                          }
                          echo "
                                  <tr>
                                    <td>".$rd->__GET('Comportamiento')."</td>
                                    <td>".$rd->__GET('AUTO')."</td>
                                    <td>".$rd->__GET('JEFE')."</td>
                                    <td>".$rd->__GET('SUB')."</td>
                                    <td>".$rd->__GET('PARES')."</td>
                                  </tr>
                          ";
                      }
                         echo "</tbody>
                            </table>
                          </td>
                        </tr>
                        </tbody>";
            endforeach;
        }

        

        public function MostrarResultadoTestJefeChart(){
          echo json_encode($this->resultadodetalle_model->MostrarResultadoIndividualDetalleJefeChart($_POST['Personal_Id'],$_POST['Evaluacion_Id'],$_POST['Cuestionario_Id']));
        }

        public function PDFMostrarResultado(){
        	$datos= $this->resultado_model->MostrarResultadoIndividualJefe($_POST['resultado_Id']);
            //haciendo que el boton guardar aparezca o desaparezca
            foreach ($datos as $ss) {
              $_SESSION["estResultado"]=1;
            }
            $var="";
            $resdetalle= $this->resultadodetalle_model->MostrarResultadoIndividualDetalleJefe($_POST['resultado_Id']);
            foreach ($datos as $r):
              $resultadoJefe=$r->__GET('PuntajeJefe');
              $resultadoAuto=$r->__GET('PuntajeAuto');
              $resultadoEvaluados=$r->__GET('PuntajeEvaluados');

                if ($resultadoJefe>0) {
                  if ($resultadoJefe<3) {
                   $resObtJefe= "<font color='Red'><b style='color:red;'>BAJO</b></font>";
                 }else{
                  if ($resultadoJefe<6) {
                    $resObtJefe= "<font color='Orange'><b style='color:Orange;'>NECESITA MEJORAR</b></font>";
                  }else{
                    if ($resultadoJefe<8) {
                      $resObtJefe= "<font color='Green'><b style='color:Green;'>SATISFACTORIO</b></font>";
                    }else{
                      if ($resultadoJefe<=10) {
                        $resObtJefe= "<font color='Blue'><b style='color:Blue;'>SOBRESALIENTE</b></font>";
                      }
                    }
                  }
                 }
                }

                if ($resultadoAuto>=0) {
                  if ($resultadoAuto<3) {
                   $resObtAuto= "<font color='Red'><b>BAJO</b></font>";
                 }else{
                  if ($resultadoAuto<6) {
                    $resObtAuto= "<font color='Orange'><b>NECESITA MEJORAR</b></font>";
                  }else{
                    if ($resultadoAuto<8) {
                      $resObtAuto= "<font color='Green'><b>SATISFACTORIO</b></font>";
                    }else{
                      if ($resultadoAuto<=10) {
                        $resObtAuto= "<font color='Blue'><b>SOBRESALIENTE</b></font>";
                      }
                    }
                  }
                 }
                }

                if ($resultadoEvaluados>=0) {
                  if ($resultadoEvaluados<3) {
                   $resObtEvaluados= "<font color='Red'><b>BAJO</b></font>";
                 }else{
                  if ($resultadoEvaluados<6) {
                    $resObtEvaluados= "<font color='Orange'><b>NECESITA MEJORAR</b></font>";
                  }else{
                    if ($resultadoEvaluados<8) {
                      $resObtEvaluados= "<font color='Green'><b>SATISFACTORIO</b></font>";
                    }else{
                      if ($resultadoEvaluados<=10) {
                        $resObtEvaluados= "<font color='Blue'><b>SOBRESALIENTE</b></font>";
                      }
                    }
                  }
                 }
                }
                $var .= " 
                        <tbody>
                          <tr>
                             <td colspan=2><b>EVALUADO:</b></td>
                          </tr>
                          <tr>
                             <td>NOMBRE: </td>
                             <td>".$r->__GET('Evaluado')."</td>
                          </tr>  
                          <tr>
                             <td>PUESTO: </td>
                             <td>".$r->__GET('PuestoEvaluado')."</td>
                          </tr>  
                          <tr>
                             <td>AREA: </td>
                             <td>".$r->__GET('Area')."</td>
                          </tr> 
                          <tr>
                             <td>FECHA INGRESO:</td>
                             <td>".date('d/m/Y', strtotime($r->__GET('FechaReingreso')))."</td>
                          </tr>
                          
                          <tr>
                            <td>RESULTADO:</td>
                            <td>
                            <table class='table' cellpadding='0' cellspacing='0'>
                                <thead>
                                  <tr>
                                      <th>AUTOEVALUACION</th>
                                      <th>JEFE</th>
                                      <th>SUBORDINADO</th>
                                  </tr>                                
                                </thead>
                                <tbody>   
                       
                     ";
                     //foreach ($resdetalle as $rd){
                              $var .= "    
                                  <tr>
                                    <td>".$r->__GET('PuntajeAuto')."</td>
                                    <td>".$r->__GET('PuntajeJefe')."</td>
                                    <td>".$r->__GET('PuntajeEvaluados')."</td>
                                </tr>

                                <tr>
                                    <td style='width: 35%;'>".$resObtAuto."</td>
                                    <td style='width: 35%;'>".$resObtJefe."</td>
                                    <td>".$resObtEvaluados."</td>
                                </tr>
                                ";
                     //}
                        $var .= "</tbody>
                        </table>
                        </td>
                        </tr><br/>
                        <tr>
                          <td colspan=2  style='width: 100%;'>
                            <table class='table text-center table-hover table-bordered'>
                              <thead>
                                <tr>
                                  <th  style='width: 30%;'>TIPO</th>
                                  <th  style='width: 30%;'>COMPETENCIA</th>
                                  <th  style='width: 10%;'>AUTOEVALUACION</th>
                                  <th  style='width: 20%;'>JEFE</th>
                                  <th  style='width: 10%;'>SUB.</th>
                                </tr> 
                              </thead>
                              <tbody>";
                      foreach ($resdetalle as $rd) {
                          $var .= "
                                  <tr>
                                    <td>".$rd->__GET('Tipo')."</td>
                                    <td>".$rd->__GET('Competencia')."</td>
                                    <td>".$rd->__GET('Auto')."</td>
                                    <td>".$rd->__GET('Jefe')."</td>
                                    <td>".$rd->__GET('Evaluados')."</td>
                                  </tr>
                          ";
                      }
                         $var .= "</tbody>
                            </table>
                          </td>
                        </tr>
                        </tbody>";
            endforeach;

          	require_once 'view/webforms/PDF/REP_Resultado.php';
        }


      public function IndexResultadoGenerales() {
        $parametro = $this->parametro_model->ListarParametros();
        $reporte = $this->reporte_model->ListarResultadoGenerales();
        require_once 'view/header.php';
        require_once 'view/webforms/rptresultadosgenerales.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
      }

      public function IndexRankingCompetencia() {
        $parametro = $this->parametro_model->ListarParametros();
        $reporte = $this->reporte_model->ListarRankingCompetencia();
        require_once 'view/header.php';
        require_once 'view/webforms/rptrankingcompetencias.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
      }

      public function IndexRankingComportamiento() {
        $parametro = $this->parametro_model->ListarParametros();
        $reporte = $this->reporte_model->ListarRankingComportamiento();
        require_once 'view/header.php';
        require_once 'view/webforms/rptrankingcomportamientos.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.reportes').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
      }
// 4072024 

      //REPORTESSSSSSSSSSS...................

    //POR COMPETENCIAS

    public function MostrarResultadoTestCompetencia(){
        $datos= $this->resultado_model->MostrarResultadoIndividualJefeRep($_POST['Personal_Id'],$_POST['Evaluacion_Id'],$_POST['Cuestionario_Id']);
        //haciendo que el boton guardar aparezca o desaparezca
        foreach ($datos as $ss) {
          $_SESSION["estResultado"]=1;
        }
        // TODO: esto es como el ejemplo del excel
        $resdetalle= $this->resultadodetalle_model->MostrarResultadoIndividualDetalleJefeReporte($_POST['Personal_Id'],$_POST['Evaluacion_Id'],$_POST['Cuestionario_Id']);
        //mostrando los ponderados de cada competencia
        $resdetallePond= $this->resultadodetalle_model->MostrarResultadoIndividualDetalleJefeChart($_POST['Personal_Id'],$_POST['Evaluacion_Id'],$_POST['Cuestionario_Id']);
        foreach ($datos as $r):
          $resultadoFinal=$r->__GET('PuntajeFinal');
          if ($resultadoFinal>0) {
            if ($resultadoFinal>=0 && $resultadoFinal<=1) {
              $resObtFinal= "<font color='Red'><b style='color:red;'>BÁSICO</b></font>";
            }
            if ($resultadoFinal>=1.01 && $resultadoFinal<=2) {
              $resObtFinal= "<font color='Orange'><b style='color:red;'>INTERMEDIO</b></font>";
            }
            if ($resultadoFinal>=2.01 && $resultadoFinal<=3) {
              $resObtFinal= "<font color='Yellow'><b style='color:red;'>AVANZADO</b></font>";
            }
            if ($resultadoFinal>=3.01 && $resultadoFinal<=4) {
              $resObtFinal= "<font color='Green'><b style='color:red;'>EXPERTO</b></font>";
            }
          }
            echo " 
                    
                    <thead>
                        <tr>
                            <th colspan=2><center>".$r->__GET('Evaluacion')."</center></th>
                        </tr>
                    </thead>
                    <tbody>
                      <tr>
                         <td colspan=2><b>EVALUADO:</b></td>
                      </tr>
                      <tr>
                         <td>NOMBRE: </td>
                         <td>".$r->__GET('Evaluado')."</td>
                      </tr>  
                      <tr>
                         <td>PUESTO: </td>
                         <td>".$r->__GET('PuestoEvaluado')."</td>
                      </tr>  
                      <tr>
                         <td>AREA: </td>
                         <td>".$r->__GET('Area')."</td>
                      </tr> 
                      <tr>
                         <td>FECHA INGRESO:</td>
                         <td>".date('d/m/Y', strtotime($r->__GET('FechaReingreso')))."</td>
                      </tr>
                      
                    <tr>
                      <td colspan=2><div class='html2pdf__page-break'></div><div style='width: 55%;''></div>
                        <canvas id='myChart'></canvas>
                      </td>
                    </tr>
                      
                    <tr>
                      <td colspan=2 style='width: 100%;'>
                        <table class='table table-bordered'>
                          <thead>
                            <tr>
                              <td colspan=2><b>REPORTE GENERAL POR COMPETENCIAS</b></td>
                            </tr>
                            <tr>
                              <th style='width: 60%;'>COMPETENCIAS</th>
                              <th style='width: 10%;'>RESULTADO GENERAL</th>
                            </tr> 
                          </thead>
                          <tbody>";
                          $prompond = 0;
                    foreach ($resdetallePond as $pond) {
                        if ($pond['SUB'] == "" && $pond['PARES'] == "") {
                          $is90 = true;
                        } else {
                          $is90 = false;
                        }
                        
                        echo "<tr>
                          <td colspan>".$pond['Competencia']."</td>";
                          if ($is90) {
                            echo "<td colspan>".  (number_format($pond['AUTO']*0.1+$pond['JEFE']*0.9,2))."</td>";
                          } else {
                              if ($r->__GET('personal_Id') != "21") {
                                   echo "<td colspan>".  (number_format($pond['AUTO']*0.1+$pond['JEFE']*0.4+$pond['SUB']*0.3+$pond['PARES']*0.2,2))."</td>";
                              } else {
                                  echo "<td colspan>".  (number_format($pond['AUTO']*0.1+$pond['SUB']*0.9,2))."</td>";
                              }
                          }
                          // <td colspan>".(number_format($pond['AUTO']*0.1+$pond['JEFE']*0.4+$pond['SUB']*0.3+$pond['PARES']*0.2,2))."</td>
                        echo "</tr>";
                        
                        // $prompond= $prompond + (($pond['AUTO']*0.1+$pond['JEFE']*0.4+$pond['SUB']*0.3+$pond['PARES']*0.2)/5);
                        if ($is90) {
                          $prompond= $prompond + (($pond['AUTO']*0.1)*$pond['PORCENTAJE'])+(($pond['JEFE']*0.9)*$pond['PORCENTAJE']);
                          
                        } else {
                            if ($r->__GET('personal_Id') != "21") {
                                $prompond= $prompond + (((($pond['AUTO']*0.1)*$pond['PORCENTAJE'])+(($pond['JEFE']*0.4)*$pond['PORCENTAJE'])+(($pond['SUB']*0.3)*$pond['PORCENTAJE'])+($pond['PARES']*0.2)*$pond['PORCENTAJE']));
                            } else {
                                $prompond= $prompond + (((($pond['AUTO']*0.1)*$pond['PORCENTAJE'])+(($pond['SUB']*0.9)*$pond['PORCENTAJE'])));
                            }
                        }

                    }
                    $bgColor = '';
                    if($prompond < 2) {
                      $bgColor = "lightcoral";
                    } else if ($prompond >= 2 && $prompond < 3) {
                      $bgColor = "yellow";
                    } else if ($prompond >= 3 && $prompond < 3.6) {
                      $bgColor = "orange";
                    } else if ($prompond >= 3.6 && $prompond <= 4) {
                      $bgColor = "green";
                    }
                     echo "
                          <tr bgcolor='".$bgColor."'>
                            <td><b>EVALUACIÓN GENERAL</b></td>
                            <td><b>".(number_format($prompond,2))."</b></td>
                          </tr>
                          </tbody>
                        </table>
                      </td>
                    </tr>
                    </tbody>";
        endforeach;
    }

    //FIN COMPETENCIAS


    //POR COMPORTAMIENTOS

    public function MostrarResultadoTestComportamiento(){
        $datos= $this->resultado_model->MostrarResultadoIndividualJefeRep($_POST['Personal_Id'],$_POST['Evaluacion_Id'],$_POST['Cuestionario_Id']);
            //haciendo que el boton guardar aparezca o desaparezca
            foreach ($datos as $ss) {
              $_SESSION["estResultado"]=1;
            }
            
            $resdetalle= $this->resultadodetalle_model->MostrarResultadoIndividualDetalleJefeReporte($_POST['Personal_Id'],$_POST['Evaluacion_Id'],$_POST['Cuestionario_Id']);
            //mostrando los ponderados de cada competencia
            $resdetallePond= $this->resultadodetalle_model->MostrarResultadoIndividualDetalleJefeChart($_POST['Personal_Id'],$_POST['Evaluacion_Id'],$_POST['Cuestionario_Id']);
            foreach ($datos as $r):
              $resultadoFinal=$r->__GET('PuntajeFinal');
              if ($resultadoFinal>0) {
                if ($resultadoFinal>=0 && $resultadoFinal<=1) {
                  $resObtFinal= "<font color='Red'><b style='color:red;'>BÁSICO</b></font>";
                }
                if ($resultadoFinal>=1.01 && $resultadoFinal<=2) {
                  $resObtFinal= "<font color='Orange'><b style='color:red;'>INTERMEDIO</b></font>";
                }
                if ($resultadoFinal>=2.01 && $resultadoFinal<=3) {
                  $resObtFinal= "<font color='Yellow'><b style='color:red;'>AVANZADO</b></font>";
                }
                if ($resultadoFinal>=3.01 && $resultadoFinal<=4) {
                  $resObtFinal= "<font color='Green'><b style='color:red;'>EXPERTO</b></font>";
                }
              }
                echo " 
                        
                        <thead>
                            <tr>
                                <th colspan=2><center>".$r->__GET('Evaluacion')."</center></th>
                            </tr>
                        </thead>
                        <tbody>
                          <tr>
                             <td colspan=2><b>EVALUADO:</b></td>
                          </tr>
                          <tr>
                             <td>NOMBRE: </td>
                             <td>".$r->__GET('Evaluado')."</td>
                          </tr>  
                          <tr>
                             <td>PUESTO: </td>
                             <td>".$r->__GET('PuestoEvaluado')."</td>
                          </tr>  
                          <tr>
                             <td>AREA: </td>
                             <td>".$r->__GET('Area')."</td>
                          </tr> 
                          <tr>
                             <td>FECHA INGRESO:</td>
                             <td>".date('d/m/Y', strtotime($r->__GET('FechaReingreso')))."</td>
                          </tr>
                          
                          
                        <tr>
                          <td colspan=2 style='width: 100%;'>
                            <table class='table text-center table-hover table-bordered'>
                              <thead>
                                <tr>
                                  <td colspan=2><b>REPORTE DE COMPETENCIAS POR COMPORTAMIENTOS</b></td>
                                </tr>
                                <tr>
                                  <th style='width: 60%;'>COMPORTAMIENTO</th>
                                  <th style='width: 10%;'>RESULTADO GENERAL</th>
                                </tr> 
                              </thead>
                              <tbody>";
                              $var="";
                      foreach ($resdetalle as $rd) {
                        if ($rd->__GET('SUB') == "" && $rd->__GET('PARES') == "") {
                          $is90 = true;
                        } else {
                          $is90 = false;
                        }
                        
                          if ($rd->__GET('Competencia')!=$var) {
                            foreach ($resdetallePond as $pond) {
                              if ($pond['Competencia']==$rd->__GET('Competencia')) {
                                echo "<tr bgcolor='#CEE3F6'>
                                  <td colspan><b>".$pond['Competencia']."</b></td>
                                  <td colspan></td>
                                </tr>";
                              }
                            }
                            
                            $var=$rd->__GET('Competencia');
                          }
                          
                          echo "
                                  <tr>
                                    <td>".$rd->__GET('Comportamiento')."</td>";
                          if ($is90) {
                            echo "<td colspan>".  (number_format($rd->__GET('AUTO')*0.1+$rd->__GET('JEFE')*0.9,2))."</td>";
                          } else {
                              if ($r->__GET('personal_Id') != 21) {
                                  echo "<td colspan>".  (number_format($rd->__GET('AUTO')*0.1+$rd->__GET('JEFE')*0.4+$rd->__GET('SUB')*0.3+$rd->__GET('PARES')*0.2,2))."</td>";
                              } else {
                                  echo "<td colspan>".  (number_format($rd->__GET('AUTO')*0.1+$rd->__GET('SUB')*0.9,2))."</td>";
                              }
                            
                          }
                                    // <td>".(number_format($rd->__GET('AUTO')*0.1+$rd->__GET('JEFE')*0.4+$rd->__GET('SUB')*0.3+$rd->__GET('PARES')*0.2,2))."</td>
                          echo       "</tr>
                          ";
                      }
                         echo "</tbody>
                            </table>
                          </td>
                        </tr>
                        </tbody>";
            endforeach;
    }

    //FIN COMPORTAMIENTOS

    //POR PERCEPCION
    public function MostrarResultadoTestAutovsDemas(){
        $datos= $this->resultado_model->MostrarResultadoIndividualJefeRep($_POST['Personal_Id'],$_POST['Evaluacion_Id'],$_POST['Cuestionario_Id']);
            //haciendo que el boton guardar aparezca o desaparezca
            foreach ($datos as $ss) {
              $_SESSION["estResultado"]=1;
            }
            
            $resdetalle= $this->resultadodetalle_model->MostrarResultadoIndividualDetalleJefeReporte($_POST['Personal_Id'],$_POST['Evaluacion_Id'],$_POST['Cuestionario_Id']);
            //mostrando los ponderados de cada competencia
            $resdetallePond= $this->resultadodetalle_model->MostrarResultadoIndividualDetalleJefeChart($_POST['Personal_Id'],$_POST['Evaluacion_Id'],$_POST['Cuestionario_Id']);
            foreach ($datos as $r):
              $resultadoFinal=$r->__GET('PuntajeFinal');
              if ($resultadoFinal>0) {
                if ($resultadoFinal>=0 && $resultadoFinal<=1) {
                  $resObtFinal= "<font color='Red'><b style='color:red;'>BÁSICO</b></font>";
                }
                if ($resultadoFinal>=1.01 && $resultadoFinal<=2) {
                  $resObtFinal= "<font color='Orange'><b style='color:red;'>INTERMEDIO</b></font>";
                }
                if ($resultadoFinal>=2.01 && $resultadoFinal<=3) {
                  $resObtFinal= "<font color='Yellow'><b style='color:red;'>AVANZADO</b></font>";
                }
                if ($resultadoFinal>=3.01 && $resultadoFinal<=4) {
                  $resObtFinal= "<font color='Green'><b style='color:red;'>EXPERTO</b></font>";
                }
              }
                echo " 
                        
                        <thead>
                            <tr>
                                <th colspan=2><center>".$r->__GET('Evaluacion')."</center></th>
                            </tr>
                        </thead>
                        <tbody>
                          <tr>
                             <td colspan=2><b>EVALUADO:</b></td>
                          </tr>
                          <tr>
                             <td>NOMBRE: </td>
                             <td>".$r->__GET('Evaluado')."</td>
                          </tr>  
                          <tr>
                             <td>PUESTO: </td>
                             <td>".$r->__GET('PuestoEvaluado')."</td>
                          </tr>  
                          <tr>
                             <td>AREA: </td>
                             <td>".$r->__GET('Area')."</td>
                          </tr> 
                          <tr>
                             <td>FECHA INGRESO:</td>
                             <td>".date('d/m/Y', strtotime($r->__GET('FechaReingreso')))."</td>
                          </tr>
                          
                          
                        <tr>
                          <td colspan=2 style='width: 80%;'>
                            <table class='table  table-hover table-bordered'>
                              <thead>
                                <tr>
                                  <td colspan=3><b>REPORTE AUTO VS HETERO PERCEPCIÓN</b></td>
                                </tr>
                                <tr>
                                  <th style='width: 50%;'>COMPETENCIAS</th>
                                  <th style='width: 25%;'><center>AUTOPERCEPCIÓN</center></th>
                                  <th style='width: 25%;'><center>HETEROPERCEPCIÓN</center></th>
                                </tr> 
                              </thead>
                              <tbody>";
                              $prompond = 0;
                        for ($f=0; $f < count($resdetallePond); $f++) {
                          if ($resdetallePond[$f]['SUB'] == "" && $resdetallePond[$f]['PARES'] == "") {
                            $is90 = true;
                          } else {
                            $is90 = false;
                          }

                          echo "<tr>
                              <td colspan>".$resdetallePond[$f]['Competencia']."</td>
                              <td colspan><center>".$resdetallePond[$f]['AUTO']."</center></td>";
                              if ($is90) {
                                echo "<td colspan><center>".number_format($resdetallePond[$f]['JEFE'],2)."</center></td>";
                              } else {
                                if ($r->__GET('personal_Id') != 21) {
                                  echo "<td colspan><center>".number_format(($resdetallePond[$f]['JEFE']+$resdetallePond[$f]['SUB']+$resdetallePond[$f]['PARES'])/3,2)."</center></td>";

                                } else {
                                  echo "<td colspan><center>".number_format($resdetallePond[$f]['SUB'],2)."</center></td>";
                                }
                              }
                            echo "</tr>";
                        }
                        // <td colspan><center>".number_format(($resdetallePond[$f]['JEFE']+$resdetallePond[$f]['SUB']+$resdetallePond[$f]['PARES'])/3,2)."</center></td>

                         echo "
                              </tbody>
                            </table>
                          </td>
                        </tr>";
                        for ($k=0; $k < count($resdetallePond); $k++) { 
                          if ($resdetallePond[$k]['SUB'] == "" && $resdetallePond[$k]['PARES'] == "") {
                            $xis90 = true;
                          } else {
                            $xis90 = false;
                          }

                          echo "
                            <tr>
                              <td colspan=2><div class='html2pdf__page-break'></div>
                              <b>".$resdetallePond[$k]['Competencia']."</b></td>
                            </tr>
                            <tr>
                              <td colspan>AUTOEVALUACIÓN</td><td colspan>".$resdetallePond[$k]['AUTO']."</td>
                            </tr>
                            <tr>
                              <td colspan>HETEROPERCEPCIÓN</td><td colspan>";
                              if ($xis90) {
                                echo number_format($resdetallePond[$k]['JEFE'],2);
                              } else {
                                if ($r->__GET('personal_Id') != 21) {
                                  echo number_format(($resdetallePond[$k]['JEFE']+$resdetallePond[$k]['SUB']+$resdetallePond[$k]['PARES'])/3,2);

                                } else {
                                  echo number_format($resdetallePond[$k]['SUB'],2);
                                }
                              }
                              echo "</td>
                            </tr>
                            <tr>
                              <td colspan=2><div style='width: 70%;'>
                                <canvas id='myChart".$k."'></canvas></div>
                              </td>
                            </tr>
                          ";
                        }
                        echo "
                        </tbody>";
            endforeach;
    }
    //FIN PERCEPCION



    
    
// 4072024   
    public function generarExcelResultadosGenerales() {
      $reporte = $this->reporte_model->ListarResultadoGenerales();

      require_once 'helpers/ExcelResultadosGenerales.php';
    }

    public function generarExcelRankingCompetencias() {
      $reporte = $this->reporte_model->ListarRankingCompetencia();

      require_once 'helpers/ExcelRankingCompetencias.php';
    }

    public function generarExcelRankingComportamientos() {
      $reporte = $this->reporte_model->ListarRankingComportamiento();

      require_once 'helpers/ExcelRankingComportamientos.php';
    }

// 4072024 
  }
?>