<?php

date_default_timezone_set('America/Lima');

require_once 'view/librerias/PHPExcel2/Classes/PHPExcel.php';
require_once 'view/librerias/PHPExcel2/Classes/PHPExcel/IOFactory.php';
// require_once '/../view/librerias/PHPExcel2/Classes/PHPExcel.php';
// require_once '/../view/librerias/PHPExcel2/Classes/PHPExcel/IOFactory.php';

$objPHPExcel = new PHPExcel();
$sheet = $objPHPExcel->setActiveSheetIndex(0);

// Definir cabecera
$sheet->setCellValue('A1', 'Código')
      ->setCellValue('B1', 'Preguntas')
      ->setCellValue('C1', 'Promedio')
      ->setCellValue('D1', 'Porcentaje');

// Aplicar estilos a la cabecera
$styleArray = [
    'font' => [
        'bold' => true,
        'color' => ['rgb' => 'FFFFFF'], // Texto blanco
        'size' => 12,
        'name' => 'Arial'
    ],
    'fill' => [
        'type' => PHPExcel_Style_Fill::FILL_SOLID,
        'color' => ['rgb' => '0070C0'] // Fondo azul
    ],
    'alignment' => [
        'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER
    ]
];

$sheet->getStyle('A1:D1')->applyFromArray($styleArray);

// Ajustar tamaño de las columnas
foreach (range('A', 'D') as $column) {
    $sheet->getColumnDimension($column)->setAutoSize(true);
}

// Insertar datos
$rowIndex = 2;
foreach ($reporte as $item) {
    $sheet->setCellValue('A' . $rowIndex, $item->Codigo);
    $sheet->setCellValue('B' . $rowIndex, $item->Pregunta);
    $sheet->setCellValue('C' . $rowIndex, $item->Promedio);
    $sheet->setCellValue('D' . $rowIndex, $item->Porcentaje . "%");
    // $sheet->setCellValue('D' . $rowIndex, $item->Avance . "%");
    $rowIndex++;
}

// Guardar el archivo
$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');
$filename = __DIR__ . DIRECTORY_SEPARATOR . 'ResultadoPreguntas.xlsx';
$objWriter->save($filename);

echo json_encode(["success" => true, "filename" => $filename]);
exit();