<?php
class AnoTrabajoModel {
    private $pdo;

    public function __CONSTRUCT() {
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Listar() {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL ano_listarC(0)");
            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $ano = new AnoTrabajo();
                $ano->__SET('ano_Id', $r->ano_Id);
                $ano->__SET('sAnoDescripcion', $r->sAnoDescripcion);
                $ano->__SET('nAnoEstado', $r->nAnoEstado);
                $result[] = $ano;
            }
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Buscar($ano_Id) {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL ano_listarC($ano_Id)");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $ano = new AnoTrabajo();
                $ano->__SET('ano_Id', $r->ano_Id);
                $ano->__SET('sAnoDescripcion', $r->sAnoDescripcion);
                $ano->__SET('nAnoEstado', $r->nAnoEstado);
                $ano->__SET('nAnoEliminado', $r->nAnoEliminado);
                $ano->__SET('nAnoUsuario_Id', $r->nAnoUsuario_Id);
                $ano->__SET('dAnoFecha_Act', $r->dAnoFecha_Act);
                $result[] = $ano;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Guardar(AnoTrabajo $data) {
        try {
            $stm = $this->pdo->prepare("CALL ano_crear(?, ?, ?, ?)");
            $stm->execute(array(
                $data->__GET('sAnoDescripcion'),
                $data->__GET('nAnoEstado'),
                $data->__GET('nAnoEliminado'),
                $data->__GET('nAnoUsuario_Id')
            ));

            echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4><i class="icon fa fa-check"></i> Información Guardada.</h4>
                    La información fue registrada satisfactoriamente.
                  </div>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Editar(AnoTrabajo $data) {
        try {
            $stm = $this->pdo->prepare("CALL ano_editar(?, ?, ?, ?, ?)");
            $stm->execute(array(
                $data->__GET('ano_Id'),
                $data->__GET('sAnoDescripcion'),
                $data->__GET('nAnoEstado'),
                $data->__GET('nAnoEliminado'),
                $data->__GET('nAnoUsuario_Id')
            ));

            echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4><i class="icon fa fa-check"></i> Éxito, </h4>
                    Se modificó correctamente.
                  </div>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Eliminar(AnoTrabajo $data){
        try {
            $stm = $this->pdo->prepare("CALL ano_ocultar(?, ?)");
            $stm->execute([
                $data->__GET('ano_Id'),
                $data->__GET('nAnoUsuario_Id')
            ]);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
}
?>