<?php
class AreaTrabajoModel {
    private $pdo;

    public function __CONSTRUCT() {
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Listar() {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL are_listarC(0)"); 
            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $area = new AreaTrabajo();
                $area->__SET('area_Id', $r->area_Id);
                $area->__SET('sAreDescripcion', $r->sAreDescripcion);
                $area->__SET('nAreEstado', $r->nAreEstado);
                $result[] = $area;
            }
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Buscar($area_Id) {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL are_listarC($area_Id)");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $are = new AreaTrabajo();
                $are->__SET('area_Id', $r->area_Id);
                $are->__SET('sAreDescripcion', $r->sAreDescripcion);
                $are->__SET('nAreEstado', $r->nAreEstado);
                $are->__SET('nAreEliminado', $r->nAreEliminado);
                $are->__SET('nAreUsuario_Id', $r->nAreUsuario_Id);
                $are->__SET('dAreFecha_Act', $r->dAreFecha_Act);
                $result[] = $are;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Guardar(AreaTrabajo $data) {
        try {
            $stm = $this->pdo->prepare("CALL are_crear(?, ?, ?, ?)"); 
            $stm->execute(array(
                $data->__GET('sAreDescripcion'),
                $data->__GET('nAreEstado'),
                $data->__GET('nAreEliminado'),
                $data->__GET('nAreUsuario_Id')
            ));

            echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4><i class="icon fa fa-check"></i> Información Guardada.</h4>
                    La información fue registrada satisfactoriamente.
                  </div>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Editar(AreaTrabajo $data) {
        try {
            $stm = $this->pdo->prepare("CALL are_editar(?, ?, ?, ?, ?)"); 
            $stm->execute(array(
                $data->__GET('area_Id'),
                $data->__GET('sAreDescripcion'),
                $data->__GET('nAreEstado'),
                $data->__GET('nAreEliminado'),
                $data->__GET('nAreUsuario_Id')
            ));

            echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4><i class="icon fa fa-check"></i> Éxito, </h4>
                    Se modificó correctamente.
                  </div>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Eliminar(AreaTrabajo $data){
        try {
            $stm = $this->pdo->prepare("CALL are_ocultar(?, ?)");
            $stm->execute([
                $data->__GET('area_Id'),
                $data->__GET('nAreUsuario_Id')
            ]);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
}
?>