<?php
class CargoTrabajoModel {
    private $pdo;

    public function __CONSTRUCT() {
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Listar() {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL car_listarC(0)"); 
            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $cargo = new CargoTrabajo();
                $cargo->__SET('cargo_Id', $r->cargo_Id);
                $cargo->__SET('sCarDescripcion', $r->sCarDescripcion);
                $cargo->__SET('nCarEstado', $r->nCarEstado);
                $result[] = $cargo;
            }
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Buscar($cargo_Id) {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL car_listarC($cargo_Id)");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $car = new CargoTrabajo();
                $car->__SET('cargo_Id', $r->cargo_Id);
                $car->__SET('sCarDescripcion', $r->sCarDescripcion);
                $car->__SET('nCarEstado', $r->nCarEstado);
                $car->__SET('nCarEliminado', $r->nCarEliminado);
                $car->__SET('nCarUsuario_Id', $r->nCarUsuario_Id);
                $car->__SET('dCarFecha_Act', $r->dCarFecha_Act);
                $result[] = $car;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Guardar(CargoTrabajo $data) {
        try {
            $stm = $this->pdo->prepare("CALL car_crear(?, ?, ?, ?)"); 
            $stm->execute(array(
                $data->__GET('sCarDescripcion'),
                $data->__GET('nCarEstado'),
                $data->__GET('nCarEliminado'),
                $data->__GET('nCarUsuario_Id')
            ));

            echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4><i class="icon fa fa-check"></i> Información Guardada.</h4>
                    La información fue registrada satisfactoriamente.
                  </div>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Editar(CargoTrabajo $data) {
        try {
            $stm = $this->pdo->prepare("CALL car_editar(?, ?, ?, ?, ?)"); 
            $stm->execute(array(
                $data->__GET('cargo_Id'),
                $data->__GET('sCarDescripcion'),
                $data->__GET('nCarEstado'),
                $data->__GET('nCarEliminado'),
                $data->__GET('nCarUsuario_Id')
            ));

            echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4><i class="icon fa fa-check"></i> Éxito, </h4>
                    Se modificó correctamente.
                  </div>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Eliminar(CargoTrabajo $data){
        try {
            $stm = $this->pdo->prepare("CALL car_ocultar(?, ?)");
            $stm->execute([
                $data->__GET('cargo_Id'),
                $data->__GET('nCarUsuario_Id')
            ]);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
}
?>