<?php


class EvaluacionModel {
    private $pdo;
    function __CONSTRUCT(){
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    public function Listar(){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL eva_listar(0)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $pro = new Evaluacion();
                $pro->__SET('evaluacion_Id', $r->evaluacion_Id);
                $pro->__SET('sEvaNombre', $r->sEvaNombre);
                $pro->__SET('dEvaInicio', $r->dEvaInicio);
                $pro->__SET('dEvaFin', $r->dEvaFin);
                $result[] = $pro;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
 
    public function Buscar($evaluacion_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL eva_listar($evaluacion_Id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $pro = new Evaluacion();
                $pro->__SET('evaluacion_Id', $r->evaluacion_Id);
                $pro->__SET('sEvaNombre', $r->sEvaNombre);
                $pro->__SET('sEvaDescripcion', $r->sEvaDescripcion);
                $pro->__SET('dEvaInicio', $r->dEvaInicio);
                $pro->__SET('dEvaFin', $r->dEvaFin);
                $pro->__SET('nEvaEstado', $r->nEvaEstado);
                $pro->__SET('nEvaOculto', $r->nEvaOculto);
                $pro->__SET('dEvaFecha_Act', $r->dEvaFecha_Act);
                $pro->__SET('nEvaUsuario_Id', $r->nEvaUsuario_Id);

                $result[] = $pro;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Crear(Evaluacion $data){
        try {
            $stm = $this->pdo->prepare("CALL eva_crear(?,?,?,?,?,?,?, @evaluacion_Id)");
            $stm->execute(array(
                                 $data->__get('sEvaNombre'),
                                 $data->__get('sEvaDescripcion'),
                                 date('Y-m-d', strtotime($data->__get('dEvaInicio'))),
                                 date('Y-m-d', strtotime($data->__get('dEvaFin'))),
                                 $data->__get('nEvaEstado'),
                                 $data->__get('nEvaOculto'),
                                 $data->__get('nEvaUsuario_Id'),
                                 ));

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $evaluacion_Id = $r->evaluacion_Id;
            }
            
            return $evaluacion_Id;

        } catch (Exception $e) {
            die($e->getMessage());
        }
    }


    public function Eliminar(Evaluacion $data){
        try {
             $stm = $this->pdo->prepare("CALL eva_ocultar(?,?)");
             $stm->execute(array($data->__get('evaluacion_Id'), $data->__get('nEvaUsuario_Id')));
        } catch (Exception $e) {
             echo die($e->getMessage());
        }
   }

   public function EditarEvaluacion(Evaluacion $data){
        try {
            $stm = $this->pdo->prepare("CALL eva_editar(?,?,?,?,?,?,?,?)");
            $stm->execute(array(
                                 $data->__get('evaluacion_Id'),
                                 $data->__get('sEvaNombre'),
                                 $data->__get('sEvaDescripcion'),
                                 date('Y-m-d', strtotime($data->__get('dEvaInicio'))),
                                 date('Y-m-d', strtotime($data->__get('dEvaFin'))),
                                 $data->__get('nEvaEstado'),
                                 $data->__get('nEvaOculto'),
                                 $data->__get('nEvaUsuario_Id'),
                                 ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    //enviar correos

    public function ObtenerEvaluados($evaluacion_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL eva_anunciar($evaluacion_Id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $pro = new Evaluacion();
                $pro->__SET('personal_Id', $r->personal_Id);
                $pro->__SET('Evaluado', $r->Evaluado);
                $pro->__SET('Correo', $r->Correo);
                $pro->__SET('Clave', $r->Clave);
                $pro->__SET('Evaluacion', $r->Evaluacion);
                $pro->__SET('Inicio', $r->Inicio);
                $pro->__SET('Fin', $r->Fin);
                $result[] = $pro;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

        public function AnunciarEvaluacion($Evaluador, $asunto, $Correo, $mensaje){
        require_once 'view/librerias/PHPMailer/PHPMailerAutoload.php';
        $mail = new PHPMailer();

        $mail->isSMTP();
        $mail->SMTPDebug = 2;
        $mail->Debugoutput = 'html';
        $mail->Host = "mail.fmsac.com"; //"mail.mbgestionhumana.com"
        $mail->Port = 465;
        $mail->SMTPAuth = true;
        $mail->SMTPSecure = 'ssl';
        $mail->Username = "avisosyalertas@fmsac.com"; // avisosyalertas@fmsac.com
        $mail->Password = "Avisos*2024"; //Avisos*2024
        $mail->setFrom('avisosyalertas@fmsac.com', 'Sistema');
        $mail->CharSet  = 'UTF-8'; // the same as 'utf-8'
        $mail->addReplyTo('avisosyalertas@fmsac.com', 'Sistema');
        $mail->addAddress($Correo,  $Evaluador);
        //$mail->AddCC($params);
        //$mail->AddBCC("alertas@modasa.com.pe"); // Copia oculta
        $mail->IsHTML(true);
        $mail->Subject = $asunto;
        $mail->msgHTML($mensaje);
        $mail->AltBody = $mensaje;
        if (!$mail->send()) {
            echo '<div class="content-header">
                        <div class="alert alert-danger" role="alert" style="margin-bottom: 0px;">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                            <strong>Mensaje Error!</strong>, '.$mail->ErrorInfo.'.
                        </div>
                  </div>';
        }
    }

}
?>
