<?php
class ModalidadContratoModel {
    private $pdo;

    public function __CONSTRUCT() {
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Listar() {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL con_listarC(0)"); 
            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $modalidad = new ModalidadContrato();
                $modalidad->__SET('contratacion_Id', $r->contratacion_Id);
                $modalidad->__SET('sConDescripcion', $r->sConDescripcion);
                $modalidad->__SET('nConEstado', $r->nConEstado);
                $result[] = $modalidad;
            }
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Buscar($contratacion_Id) {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL con_listarC($contratacion_Id)");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $modalidad = new ModalidadContrato();
                $modalidad->__SET('contratacion_Id', $r->contratacion_Id);
                $modalidad->__SET('sConDescripcion', $r->sConDescripcion);
                $modalidad->__SET('nConEstado', $r->nConEstado);
                $modalidad->__SET('nConEliminado', $r->nConEliminado);
                $modalidad->__SET('nConUsuario_Id', $r->nConUsuario_Id);
                $modalidad->__SET('dConFecha_Act', $r->dConFecha_Act);
                $result[] = $modalidad;
            }
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Guardar(ModalidadContrato $data) {
        try {
            $stm = $this->pdo->prepare("CALL con_crear(?, ?, ?, ?)"); 
            $stm->execute(array(
                $data->__GET('sConDescripcion'),
                $data->__GET('nConEstado'),
                $data->__GET('nConEliminado'),
                $data->__GET('nConUsuario_Id')
            ));

            echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4><i class="icon fa fa-check"></i> Información Guardada.</h4>
                    La información fue registrada satisfactoriamente.
                  </div>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Editar(ModalidadContrato $data) {
        try {
            $stm = $this->pdo->prepare("CALL con_editar(?, ?, ?, ?, ?)"); 
            $stm->execute(array(
                $data->__GET('contratacion_Id'),
                $data->__GET('sConDescripcion'),
                $data->__GET('nConEstado'),
                $data->__GET('nConEliminado'),
                $data->__GET('nConUsuario_Id')
            ));

            echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4><i class="icon fa fa-check"></i> Éxito, </h4>
                    Se modificó correctamente.
                  </div>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Eliminar(ModalidadContrato $data){
        try {
            $stm = $this->pdo->prepare("CALL con_ocultar(?, ?)");
            $stm->execute([
                $data->__GET('contratacion_Id'),
                $data->__GET('nConUsuario_Id')
            ]);
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
}
