<?php

class OrganigramaModel {
    private $pdo;
    public function __CONSTRUCT(){
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Hijos($idPadre){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL org_hijos($idPadre)");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $org = new Organigrama();
                $org->__SET('Organigrama_Id', $r->Organigrama_Id);
                $org->__SET('sOrgCodigo', $r->sOrgCodigo);
                $org->__SET('sOrgDescripcion', $r->sOrgDescripcion);
                $org->__SET('nOrgPadre', $r->nOrgPadre);
                $org->__SET('nOrgTipo', $r->nOrgTipo);
                $org->__SET('nOrgEstado', $r->nOrgEstado);
                $org->__SET('nOrgEliminado', $r->nOrgEliminado);
                $org->__SET('dOrgFecha_Act', $r->dOrgFecha_Act);
                $org->__SET('Usuario_Id', $r->Usuario_Id);
                $result[] = $org;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    public function Padre(Organigrama $data){
        try {
            $stm = $this->pdo->prepare("CALL org_padre(?,?)");
            $stm->execute(array($data->__get('Organigrama_Id'),
                                $data->__get('nOrgPadre')));
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }  
    public function Listar(){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL org_listar(0)");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $org = new Organigrama();
                $org->__SET('Organigrama_Id', $r->Organigrama_Id);
                $org->__SET('sOrgCodigo', $r->sOrgCodigo);
                $org->__SET('sOrgDescripcion', $r->sOrgDescripcion);
                $org->__SET('nOrgPadre', $r->nOrgPadre);
                $org->__SET('nOrgTipo', $r->nOrgTipo);
                $org->__SET('nOrgEstado', $r->nOrgEstado);
                $org->__SET('nOrgEliminado', $r->nOrgEliminado);
                $org->__SET('dOrgFecha_Act', $r->dOrgFecha_Act);
                $org->__SET('Usuario_Id', $r->Usuario_Id);
                $result[] = $org;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ListarCat(){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL orgcat_listar(0)");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $org = new Organigrama();
                $org->__SET('OrgCat_Id', $r->OrgCat_Id);
                $org->__SET('sOrgCatDescripcion', $r->sOrgCatDescripcion);
                $result[] = $org;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }   
    
    public function Buscar($Organigrama_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL org_listar($Organigrama_Id)");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $org = new Organigrama();
                $org->__SET('Organigrama_Id', $r->Organigrama_Id);
                $org->__SET('sOrgCodigo', $r->sOrgCodigo);
                $org->__SET('sOrgDescripcion', $r->sOrgDescripcion);
                $org->__SET('nOrgPadre', $r->nOrgPadre);
                $org->__SET('nOrgTipo', $r->nOrgTipo);
                $org->__SET('nOrgEstado', $r->nOrgEstado);
                $org->__SET('nOrgEliminado', $r->nOrgEliminado);
                $org->__SET('dOrgFecha_Act', $r->dOrgFecha_Act);
                $org->__SET('Usuario_Id', $r->Usuario_Id);
                $result[] = $org;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }


    //buscar por id de padre para el modulo de evaluaciones

    public function BuscarPadre($nOrgPadre){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL org_buscarpadre($nOrgPadre)");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $org = new Organigrama();
                $org->__SET('Organigrama_Id', $r->Organigrama_Id);
                $org->__SET('sOrgCodigo', $r->sOrgCodigo);
                $org->__SET('sOrgDescripcion', $r->sOrgDescripcion);
                $org->__SET('nOrgPadre', $r->nOrgPadre);
                $org->__SET('nOrgTipo', $r->nOrgTipo);
                $org->__SET('nOrgEstado', $r->nOrgEstado);
                $org->__SET('nOrgEliminado', $r->nOrgEliminado);
                $org->__SET('dOrgFecha_Act', $r->dOrgFecha_Act);
                $org->__SET('Usuario_Id', $r->Usuario_Id);
                $result[] = $org;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }


    public function Guardar(Organigrama $data){
        try {
            $stm = $this->pdo->prepare("CALL org_crear(?,?,?,?,?,?,?)");
            $stm->execute(array(
                                $data->__get('sOrgCodigo'),
                                $data->__get('sOrgDescripcion'),
                                $data->__get('nOrgPadre'),
                                $data->__get('nOrgTipo'),
                                $data->__get('nOrgEstado'),
                                $data->__get('nOrgEliminado'),
                                $data->__get('Usuario_Id')
                         ));
            echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito información guardado</strong>, los datos fueron registrados correctamente.
                  </div>';
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Editar(Organigrama $data){
        try {
            $stm = $this->pdo->prepare("CALL org_editar(?,?,?,?,?,?,?,?)");
            $stm->execute(array(
                                 $data->__get('sOrgCodigo'),
                                 $data->__get('sOrgDescripcion'),
                                 $data->__get('nOrgPadre'),
                                 $data->__get('nOrgTipo'),
                                 $data->__get('nOrgEstado'),
                                 $data->__get('nOrgEliminado'),
                                 $data->__get('Usuario_Id'),
                                 $data->__get('Organigrama_Id')
                                ));
            echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito información editado</strong>, los datos fueron editados correctamente.
                  </div>';  
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Eliminar(Organigrama $data){
        try {
            $stm = $this->pdo->prepare("CALL org_eliminar(?)");
            $stm->execute(array($data->__get('organigrama_Id')));
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
}
