<?php
class ResultadodetalleModel
{
    private $pdo;
    function __CONSTRUCT()
    {
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Listar(){
        try {
            $result = array();
            $stm = $this->pdo->prepare("call res_listar(0)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $res = new Resultado();

                $res->__SET('Personal', $r->Personal);
                $res->__SET('Evaluacion', $r->Evaluacion);
                $res->__SET('Cuestionario', $r->sCueCodigo);
                $res->__SET('nResEstado', $r->nResEstado);
                $res->__SET('Area', $r->Area);
                $res->__SET('Cargo', $r->Cargo);
                $res->__SET('Ano', $r->Ano);
                $res->__SET('Contrato', $r->Contrato);
                $res->__SET('Edad', $r->Edad);

                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    //listar de los usuarios

    public function ListarEvaUsu($Evaluador_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("call res_listar($Evaluador_Id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $res = new Resultado();

                $res->__SET('Personal', $r->Personal);
                $res->__SET('Puesto', $r->Puesto);
                $res->__SET('Evaluacion', $r->Evaluacion);
                $res->__SET('Cuestionario', $r->sCueCodigo);
                $res->__SET('nResEstado', $r->nResEstado);
                $res->__SET('cuestionario_Id', $r->cuestionario_Id);
                $res->__SET('evaluaciondetalle_Id', $r->evaluaciondetalle_Id);
                $res->__SET('personal_Id', $r->personal_Id);

                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ObtenerCuestionarioTest($cuestionario_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("call cuedet_listar($cuestionario_Id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $res = new Resultado();

                $res->__SET('cuestionario_Id', $r->cuestionario_Id);
                $res->__SET('competencia_Id', $r->competencia_Id);
                $res->__SET('pregunta_Id', $r->pregunta_Id);
                $res->__SET('sPreDescripcion', $r->sPreDescripcion);
                $res->__SET('sComNombre', $r->sComNombre);
                $res->__SET('competenciadetalle_Id', $r->competenciadetalle_Id);
                $res->__SET('sComDetNombre', $r->sComDetNombre);
                $res->__SET('nComDetOrden', $r->nComDetOrden);
                $res->__SET('nComDetPorcentaje', $r->nComDetPorcentaje);
                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function guardarCuestionarioDetalleTest(Resultadodetalle $data)
    {
        try {
            $resultado_Id = 1;
            $stm = $this->pdo->prepare("CALL resdet_crear(?,?,?)");
            $stm->execute(array(
                $data->__get('resultado_id'),
                $data->__get('pregunta_Id'),
                $data->__get('nresdetValor')
            ));
            return $resultado_Id;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function MostrarResultadoIndividualDetalle($resultado_id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("call resdet_listar($resultado_id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $res = new Resultadodetalle();

                $res->__SET('Tipo', $r->Tipo);
                $res->__SET('Competencia', $r->Competencia);
                $res->__SET('Puntaje', $r->Puntaje);


                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    //mostramos los resultados para obtener al editar una evaluacion

    public function MostrarResultadoDetalleEdit($resultado_id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("call resdet_obtenerOrdenado($resultado_id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $res = new Resultadodetalle();

                $res->__SET('resultado_Id', $r->resultado_Id);
                $res->__SET('pregunta_Id', $r->preguntaResultadoId);
                $res->__SET('nresdetValor', $r->nresdetValor);


                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    //chart del evaluado por el jefe

    public function MostrarResultadoIndividualDetalleChart($resultado_id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("call resdet_listar($resultado_id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $pro = array(
                    'Competencia' => $r->Competencia,
                    'Puntaje' => $r->Puntaje
                );
                $result[] = $pro;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }


    public function MostrarResultadoIndividualDetalleJefe($resultado_id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("call resdet_evaluado($resultado_id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $res = new Resultadodetalle();

                $res->__SET('Tipo', $r->Tipo);
                $res->__SET('Competencia', $r->Competencia);
                $res->__SET('Auto', $r->Auto);
                $res->__SET('Jefe', $r->Jefe);
                $res->__SET('Evaluados', $r->Evaluados);


                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    //muestra el detalle de la evaluacion en la evaluacion de reportes
    public function MostrarResultadoIndividualDetalleJefeReporte($Evaluado_Id, $Evaluacion_Id, $Cuestionario_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("call res_ConsolidadoDetallado($Evaluado_Id,$Evaluacion_Id,$Cuestionario_Id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $res = new Resultadodetalle();

                $res->__SET('Competencia', $r->Competencia);
                $res->__SET('Comportamiento', $r->Comportamiento);
                $res->__SET('AUTO', $r->AUTO);
                $res->__SET('JEFE', $r->JEFE);
                $res->__SET('SUB', $r->SUB);
                $res->__SET('PARES', $r->PARES);


                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    //chart del la autoevaluacion del jefe

    public function MostrarResultadoIndividualDetalleJefeChart($Evaluado_Id, $Evaluacion_Id, $Cuestionario_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("call res_ConsolidadoGrafico($Evaluado_Id,$Evaluacion_Id,$Cuestionario_Id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $pro = array(
                    'Competencia' => $r->Competencia,
                    'AUTO' => $r->AUTO,
                    'JEFE' => $r->JEFE,
                    'SUB' => $r->SUB,
                    'PARES' => $r->PARES,
                    'PORCENTAJE' => $r->PORCENTAJE
                );
                $result[] = $pro;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
}
