var garantias = (function(garantias, undefined){
    
    var _table = $('#example1'),
        _changes = function(){
                        
            $('#Protocologe_Id').on('changed.bs.select', function (e) {
                
                $("#Cliente_Id").selectpicker('val', $(this).find('option:selected').data('codigo'));
                
            });
            
            $('#nGarAnio').on('changed.bs.select', function (e) {
                
                var dGarFechaActivacion = $("#dGarFechaActivacion").val();
                alert(dGarFechaActivacion);
                if(dGarFechaActivacion != ""){
                    
                    var dateAct = dGarFechaActivacion.split("-"),
                        anio = parseInt(dateAct[2]) + parseInt(e.target.value), 
                        datepicker = $('.dGarFecha');

                    datepicker.data('DateTimePicker').date(dateAct[0] + '-' + dateAct[1] + '-' + anio);
                    
                } else {
                    
                    $("#resultado").ATDmessage({
                        type: 'warning',
                        header: 'Advertencia',
                        message: 'Debe de seleccionar una fecha de activación.'
                    });
                    
                    $(this).selectpicker("val", "");
                    
                }
            });

        },
        _Limpiar = function(){
            $('#Garantia_Id').val("0");
            $('#Protocologe_Id').selectpicker("val", "");
            $('#dGarFechaActivacion').val("");
            $('#nGarAnio').selectpicker("val", "1");
            $('#dGarFecha').val("");
            $('#sGarCodigoActivacion').val("");
        },
        _callbackDoneListar = function(data){

            $("#example1 tbody").html(data);
        
        },
        _callbackAlwaysListar = function(){
            garantias.dataTable();
            _showModal();
            _editar();
        },  
        
        _showModal = function(){

            $('#modal-eliminar').on('show.bs.modal', function (event) {
                var button = $(event.relatedTarget);
                var codigo = button.data('codigo');
                
                var modal = $(this)
                modal.find('.modal-body input').val(codigo)
            })

        },
        
        _editar = function(){
            $(".editar").click(function(){
            
                myApp.ajax({
                
                    url: "?c=Garantias&a=Filter",
                    data: {Garantia_Id: $(this).data('codigo')},
                    callbackDone: _callbackDoneEditar
                
                }); 
            
            });
            
        },
        
        _callbackDoneEditar = function(data){
            
            $('#Protocologe_Id').prop('disabled', true);
            
            $("#Garantia_Id").val(data[0].Garantias_Id)
            $("#Protocologe_Id").selectpicker("val", data[0].Protocologe_Id)
            $("#Cliente_Id").selectpicker("val", data[0].Cliente_Id)
            $("#dGarFechaActivacion").val(myApp.dateDDMMYYYY(data[0].dGarFechaActivacion, '-'))
            $("#nGarAnio").selectpicker("val", data[0].nGarAnio)
            $("#dGarFecha").val(myApp.dateDDMMYYYY(data[0].dGarFecha, '-'));
            $("#sGarCodigoActivacion").val(data[0].sGarCodigoActivacion);
            
            $("#modal-nuevo").modal("show");
        };
    
    garantias.clickFiltrar = function(){
        
        $(".filtrar").click(function(){
            
            if($("#FrmFiltrar").valid()){
            
                _table.dataTable().fnClearTable();
                _table.dataTable().fnDestroy();

                 myApp.ajax({

                    url: "?c=Garantias&a=Listar",
                    data: {
                        FechaInicio: $("#FechaInicio").val(),
                        FechaFin: $("#FechaFin").val()
                    },
                    dataType : "html",
                    callbackDone: _callbackDoneListar,
                    callbackAlways: _callbackAlwaysListar

                }); 
                
            }
        });
        
    },
    
    garantias.picker = function(){
        
        $('.dGarFecha, .dGarFechaActivacion, #FechaInicio, #FechaFin ').datetimepicker({
            defaultDate: '01/01/2017',
            format: 'DD-MM-YYYY'
        });
                
        $(".selectPicker").selectpicker({  
            size: 5,
            liveSearch: true
        });
                
        _changes();
        
    },
    
    garantias.clickSave = function(){
        
        $("#GuardarGarantia").click(function(){
            
            if($("#FrmGuardarGarantias").valid()){
                
                $.ajax({
                    url: '?c=Garantias&a=Guardar',
                    data: {
                        "Garantia_Id"          : $('#Garantia_Id').val(),
                        "Protocologe_Id"       : $('#Protocologe_Id').val(),
                        "Equipo_Id"            : $('#Protocologe_Id option:selected').data('equipo'),            
                        "Cliente_Id"           : $('#Cliente_Id').val(),
                        "dGarFechaActivacion"  : $('#dGarFechaActivacion').val(),
                        "nGarAnio"             : $('#nGarAnio').val(),
                        "dGarFecha"            : $('#dGarFecha').val(),
                        "sGarCodigoActivacion" : $('#sGarCodigoActivacion').val()
                    },
                    type: 'POST',
                    success: function(data){
                        _Limpiar();
                        // $("#resultado").ATDmessage({
                        //     header: 'Exito',
                        //     message: 'Los datos fueron guardados correctamente'
                        // });
                        
                        // _table.dataTable().fnClearTable();
                        // _table.dataTable().fnDestroy();
                        $("#resultado").html(data);
                        $('html, body').animate({scrollTop: '0px'}, 1000);
                        garantias.listar();
                        
                        //window.location.href = '?c=Garantias&a=Index';
                        //$("#modal-nuevo").hide();

                        var estados= $("#Estado").val();
                        if (estados==1) {}else{if (estados==2) {$("#modal-nuevo").hide();}}
                    }
                });
                
            }
            
        });
        
    },
    
    garantias.validar = function(){
        $.validator.addMethod("modasaDate", function (value, element) {
            return value.match(/^\d\d?\-\d\d?\-\d\d\d\d$/);
        }, "Please enter a date in the format dd-mm-yyyy.");
        
        $("#FrmGuardarGarantias").validate({
            rules: {
                Protocologe_Id: {
                    required: true
                },
                Cliente_Id: {
                    required: true
                },
                dGarFechaActivacion: {
                    required: true,
                    modasaDate: true
                },
                nGarAnio: {
                    required: true
                },
                dGarFecha: {
                    required: true,
                    modasaDate: true
                }
            },
            messages: {
                Protocologe_Id: {
                    required: "Debe de seleccionar un equipo por favor."
                },
                Cliente_Id: {
                    required: "Debe de seleccionar un cliente por favor."
                },
                dGarFechaActivacion: {
                    required: "Ingresar fecha por favor.",
                    modasaDate: "Fecha invalida."
                },
                nGarAnio: {
                    required: "Ingrese año por favor."
                },
                dGarFecha: {
                    required: "Ingrese fecha por favor.",
                    modasaDate: "Fecha invalida."
                }
            }
        });
        
    },
    
    garantias.validarFiltro = function(){
        $.validator.addMethod("modasaDate", function (value, element) {
            return value.match(/^\d\d?\-\d\d?\-\d\d\d\d$/);
        }, "Please enter a date in the format dd-mm-yyyy.");
        
        $("#FrmFiltrar").validate({
            rules: {
                FechaInicio: {
                    required: true,
                    modasaDate: true
                },
                FechaFin: {
                    required: true,
                    modasaDate: true
                }
            },
            messages: {
                FechaInicio: {
                    required: "Ingresar fecha por favor.",
                    modasaDate: "Fecha invalida."
                },
                FechaFin: {
                    required: "Ingrese fecha por favor.",
                    modasaDate: "Fecha invalida."
                }
            }
        });
        
    },
    
    garantias.modalHide = function(){
        $('#modal-nuevo').on('hide.bs.modal', function () {
            
            $('#Protocologe_Id').prop('disabled', false);
            $('#resultado').html("");
            
        });
    },
    
    garantias.listar = function(){
        
        myApp.ajax({

            url: "?c=Garantiascliente&a=Listar",
            //data: json,
            dataType : "html",
            contentType: "text/html; charset=utf-8",
            callbackDone: _callbackDoneListar,
            callbackAlways: _callbackAlwaysListar

         }); 
        
    },
    
    garantias.dataTable = function(){
        
        jQuery.fn.dataTableExt.oSort['fecha-asc'] = function(a, b) {
            var ukDatea = a.split('-');
            var ukDateb = b.split('-');

            var x = (ukDatea[2] + ukDatea[1] + ukDatea[0]) * 1;
            var y = (ukDateb[2] + ukDateb[1] + ukDateb[0]) * 1;

            return ((x < y) ? -1 : ((x > y) ? 1 : 0));
        };

        jQuery.fn.dataTableExt.oSort['fecha-desc'] = function(a, b) {
            var ukDatea = a.split('-');
            var ukDateb = b.split('-');

            var x = (ukDatea[2] + ukDatea[1] + ukDatea[0]) * 1;
            var y = (ukDateb[2] + ukDateb[1] + ukDateb[0]) * 1;

            return ((x < y) ? 1 : ((x > y) ? -1 : 0));
        };
                
        _table.dataTable();
        
    };
    
    return garantias;
})(garantias || {});

$(function(){
    
    garantias.listar();
    garantias.picker();
    garantias.validar();
    garantias.validarFiltro();
    garantias.clickSave();
    garantias.clickFiltrar();
    garantias.modalHide();
    $("#nGarAnio").selectpicker("val", "1");
});