<!-- Content Header (Page header) -->
<section class="content-header">
    <h1>
        Programación de Evaluación
        <small></small>
    </h1>
    <ol class="breadcrumb">
        <li><a href="wfamain.php"><i class="fa fa-dashboard"></i> Inicio</a></li>
        <li><a href="#">Evaluación</a></li>
    </ol>
</section>

<!-- Main content -->
<section class="content">
    <div class="row">
        <div class="col-xs-12">
            <div class="box box-primary">
                <form action="javascript:EditarEvaluacion();" method="POST" id="FrmEvaluacion">
                    <div class="box-header">
                        <h3 class="box-title">Editar Evaluación</h3>
                    </div>
                    <!-- /.box-header -->
                    <div class="box-body">
                        <div id="resultado"></div>
                        <div class="row">
                            <input type="hidden" id="evaluacion_Id" value="<?php echo isset($r) ? $r->__GET('evaluacion_Id') : ''; ?>">
                            <div class="col-sm-12 form-group">
                                <label for="">Nombre</label>
                                <input type="text" class="form-control" required="required" id="sEvaNombre" name="sEvaNombre" value="<?php echo isset($r) ? $r->__GET('sEvaNombre') : ''; ?>">
                            </div>

                            <div class="col-md-12">
                                <div class="form-group">
                                    <label for="descripcion">Descripción</label>
                                    <textarea class="form-control" name="sEvaDescripcion" id="sEvaDescripcion" style="resize: none;"><?php echo isset($r) ? $r->__get('sEvaDescripcion') : ''; ?></textarea>
                                </div>
                            </div>

                            <div class="col-md-3 form-group">
                                <label>Fecha Inicio</label>
                                <input type="text" class="form-control" name="dEvaInicio" id="dEvaInicio" required="required" placeholder="Fecha Inicio" value="<?php echo isset($r) ? date_format(date_create($r->__GET('dEvaInicio')), 'd-m-Y') : ''; ?>">
                            </div>

                            <div class="col-md-3 form-group">
                                <label>Fecha Fin</label>
                                <input type="text" class="form-control" name="dEvaFin" id="dEvaFin" required="required" placeholder="Fecha Fin" value="<?php echo isset($r) ? date_format(date_create($r->__GET('dEvaFin')), 'd-m-Y') : ''; ?>">
                            </div>

                            <div class="col-md-3 form-group">
                                <label>Estado</label>
                                <select class="form-control" name="nEvaEstado" id="nEvaEstado" onchange="TipoPrvClien()">
                                    <option value="1" <?php echo isset($r) ? $r->__GET('nEvaEstado') == 1 ? 'selected' : '' : ''; ?>>Habilitado</option>
                                    <option value="2" <?php echo isset($r) ? $r->__GET('nEvaEstado') == 2 ? 'selected' : '' : ''; ?>>Deshabilitado</option>
                                </select>
                            </div>

                        </div>
                    </div>
                    <!-- /.box-body -->
                </form>

                <div class="box-body">
                    <div class="col-md-12 mb-3">
                        <div class="row align-items-end">
                            <div class="col-md-2">
                                <h4 style="margin-bottom: 10px;">Tabla de Asignaciones</h4>
                            </div>
                            <!-- Selector de Cuestionario -->
                            <div class="col-md-4">
                                <label>Cuestionario</label>
                                <select class="form-control" name="nEvaDetCuestionario_Id" id="nEvaDetCuestionario_Id">
                                    <option value="">Seleccione el cuestionario</option>
                                    <?php foreach ($cuestionario as $cue): ?>
                                        <option value="<?php echo $cue->__GET('cuestionario_Id'); ?>">
                                            <?php echo $cue->__GET('sCueNombre'); ?>
                                        </option>
                                    <?php endforeach; ?>
                                </select>
                            </div>

                            <!-- Selector de Personal -->
                            <div class="col-md-4">
                                <label>Personal</label>
                                <select class="form-control" name="nEvaDetEvaluado_Id" id="nEvaDetEvaluado_Id">
                                    <option value="">Seleccione el personal</option>
                                    <?php foreach ($personal as $per): ?>
                                        <option value="<?php echo $per->__GET('Personal_Id'); ?>">
                                            <?php echo $per->__GET('sPerApePaterno') . ' ' . $per->__GET('sPerApeMaterno') . ', ' . $per->__GET('sPerNombres'); ?>
                                        </option>
                                    <?php endforeach; ?>
                                </select>
                            </div>

                            <!-- Botón Agregar Fila -->
                            <div class="col-md-2">
                                <button onclick="agregarFila()" class="btn btn-success">Agregar Fila</button>
                            </div>
                        </div>
                    </div>

                    <!-- Separador -->
                    <hr style="margin-top: 20px;">

                    <!-- Tabla de Datos -->
                    <table id="tbldetEva" class="table table-bordered text-center mt-3">
                        <thead>
                            <tr>
                                <th>Evaluado</th>
                                <th>Cuestionario</th>
                                <th>Operaciones</th>
                            </tr>
                        </thead>
                        <tbody id="tbodyeva">
                            <?php if (isset($datosdet) && is_array($datosdet) && !empty($datosdet)): ?>
                                <?php foreach ($datosdet as $detalle): ?>
                                    <tr data-evaluado-id="<?php echo $detalle['EvaluadoId']; ?>">
                                        <td><?php echo htmlspecialchars($detalle['Evaluado']); ?></td>
                                        <td><?php echo htmlspecialchars($detalle['Cuestionario']); ?></td>
                                        <td><button class="btn btn-danger btn-sm" onclick="eliminarFila(this)">Eliminar</button></td>
                                    </tr>
                                <?php endforeach; ?>
                            <?php else: ?>
                                <tr id="mensajeVacio">
                                    <td colspan="3" class="text-center">No hay datos</td>
                                </tr>
                            <?php endif; ?>
                        </tbody>
                    </table>
                </div>

                <div class="box-footer">
                    <button type="submit" class="btn btn-primary btn-flat" onclick="EditarEvaluacion(); return false;">Guardar información</button>
                    <a href="?c=Evaluacion&a=Index" class="btn btn-danger btn-flat">Cancelar</a>
                </div>

            </div><!-- /.box -->
        </div><!-- /.col -->
    </div><!-- /.row -->
</section><!-- /.content -->

<!-- /Modal modal-eliminar -->
<script src="view/librerias/dist/js/funcionesEvaluacion.js"></script>


